package com.aliyun.odps.spark.examples.makedata_ad.v20240718

import com.aliyun.odps.TableSchema
import com.aliyun.odps.data.Record
import com.aliyun.odps.spark.examples.myUtils.{ParamUtils, env}
import org.apache.spark.rdd.RDD
import org.apache.spark.sql.{SparkSession}

import scala.collection.JavaConversions._
import scala.collection.mutable.ArrayBuffer

/*

 */

object makedata_ad_32_bucket_hive_test {
  def main(args: Array[String]): Unit = {

    val spark = SparkSession
      .builder()
      .appName(this.getClass.getName)
      .getOrCreate()
    val sc = spark.sparkContext

    // 2 读取odps+表信息
    val odpsOps = env.getODPS(sc)

    // 1 读取参数
    val param = ParamUtils.parseArgs(args)
    val project = param.getOrElse("project", "loghubods")
    val table = param.getOrElse("table", "ad_easyrec_train_data_v1")
    val partition = "dt=20250101"

    val result = new ArrayBuffer[String]()

    result.add("0\tb2_6h_click:0.01\tabcode_ab0:0.1\tb2_3d_conver:0.3\tb9_3d_conver*log(view):0.12\tb8_yesterday_ecpm:0.89\tb8_7d_click:0.03\tb3_1d_ctcvr:0.99\tb7_14d_click:0.04\tb2_today_conver:0.01\tb5_12h_click:0.04\tb2_today_conver*log(view):0.01\tb9_7d_ctr:0.96\tb2_3h_ctr:0.93\tb2_1d_ctcvr:0.96\tb4_1d_ctr:0.96\tb8_12h_conver*log(view):0.05\tb5_1d_cvr:0.99\tb4_12h_ctr:0.97\tb5_3d_ecpm:0.98\tb4_1d_conver:0.02\tb2_7d_conver*log(view):0.61\tb8_1d_ctcvr:0.99\tb9_7d_conver*log(view):0.11\tapptype_4:0.1\tb5_12h_conver*log(view):0.07\tb4_1d_click:0.03\tb9_1d_ctcvr:0.99\tb5_3d_ctcvr:0.99\tb4_yesterday_conver*log(view):0.04\tb4_yesterday_conver:0.02\tb2_12h_ecpm:0.92\tb2_12h_cvr:0.96\tb9_1d_cvr:0.98\tb8_1d_ctr:0.96\tb3_7d_conver*log(view):0.04\tb8_12h_ecpm:0.98\tb3_yesterday_ctr:0.54\tcid_11021:0.1\tb5_7d_conver:0.06\tb8_3d_conver:0.04\tb2_3d_cvr:0.92\tb3_3d_conver:0.04\tb9_yesterday_conver:0.1\tb5_1d_conver*log(view):0.1\tb5_7d_ctcvr:0.99\tb4_7d_ctr:0.96\tb5_7d_cvr:0.99\tb4_yesterday_cvr:0.98\tb9_12h_conver*log(view):0.11\tb2_12h_ctcvr:0.92\tb5_3d_ctr:0.96\tb9_7d_cvr:0.99\tb4_1d_cvr:0.98\tb7_7d_click:0.04\tb3_1d_ctr:0.9500000000000001\tb5_1d_conver:0.1\tb8_yesterday_conver*ctcvr:0.19\tb2_3d_conver*log(view):0.3\tb2_3d_ecpm:0.9400000000000001\tb8_7d_ctr:0.96\tb9_1d_ecpm:0.98\tb4_7d_ecpm:0.98\tb8_1d_cvr:0.91\tb4_3d_ctcvr:0.99\tb9_3d_conver:0.11\tb4_12h_cvr:0.99\tb4_3d_conver:0.02\tb3_1d_click:0.03\tb2_12h_conver:0.13\tb3_1d_ecpm:0.97\tb9_yesterday_ctr:0.67\tb3_1d_conver*ctcvr:0.17\tb4_7d_conver*ctcvr:0.11\tb3_yesterday_conver*ctcvr:0.16\tb4_yesterday_ecpm:0.97\tb9_3d_ctr:0.96\tb3_3d_conver*log(view):0.04\tb2_yesterday_conver*log(view):0.2\tb7_14d_ctr:0.68\tb2_12h_conver*ctcvr:0.35000000000000003\tweight:0.03\tb5_yesterday_conver:0.1\tb3_7d_ctr:0.9500000000000001\tb9_12h_ctr:0.9500000000000001\tb3_12h_ctcvr:0.99\tb2_12h_conver*log(view):0.13\tb4_7d_ctcvr:0.99\tb8_7d_conver*ctcvr:0.11\tb8_yesterday_conver*log(view):0.08\tb9_7d_ecpm:0.98\tb4_3d_conver*log(view):0.02\tb4_1d_conver*ctcvr:0.21\tb2_7d_conver*ctcvr:0.96\tb8_12h_ctcvr:0.99\tb4_7d_cvr:0.98\tb9_1d_click:0.12\tb5_7d_conver*ctcvr:0.18\tb8_7d_cvr:0.89\tb4_3d_ecpm:0.98\tb2_6h_ctr:0.91\tb2_1d_conver*ctcvr:0.59\tb5_1d_conver*ctcvr:0.32\tb3_7d_conver*ctcvr:0.08\tb5_yesterday_conver*log(view):0.09\tb7_7d_ctr:0.68\tb3_12h_ctr:0.9\tdayofweek_1:0.1\tb2_today_ctr:0.93\tb9_7d_conver*ctcvr:0.19\tb4_12h_conver:0.02\tb4_3d_ctr:0.96\tb8_1d_conver*ctcvr:0.21\tb9_12h_conver:0.07\tb5_3d_cvr:0.99\tb4_7d_conver*log(view):0.02\tb5_7d_conver*log(view):0.05\tb9_1d_conver*ctcvr:0.27\tb2_today_ctcvr:0.93\tb4_12h_ctcvr:0.99\tb2_12h_click:0.04\tb8_yesterday_ctr:0.85\tb9_3d_cvr:0.99\tb9_12h_ctcvr:0.99\tb9_yesterday_cvr:0.6900000000000001\tb2_1d_click:0.15\tb8_3d_ctr:0.96\tb3_3d_ctcvr:0.99\tb3_yesterday_ctcvr:0.62\tb5_3d_click:0.04\tb9_yesterday_conver*ctcvr:0.26\tb8_1d_click:0.05\tb3_yesterday_cvr:0.51\tb5_12h_ecpm:0.98\tb3_7d_ctcvr:0.99\tb2_yesterday_ctr:0.54\tb9_12h_cvr:0.99\tb3_12h_conver*log(view):0.02\tb8_1d_ecpm:0.98\tb8_1d_conver*log(view):0.06\tadverid_142:0.1\tb4_yesterday_ctcvr:0.99\tb2_7d_ctr:0.93\tb9_3d_ctcvr:0.99\tb3_3d_ctr:0.9500000000000001\tb4_3d_conver*ctcvr:0.15\tb9_1d_conver*log(view):0.14\tb5_yesterday_ctr:0.77\tb8_yesterday_ctcvr:0.88\tb3_yesterday_conver*log(view):0.08\tb4_7d_click:0.02\tb2_7d_conver:0.61\tb3_yesterday_ecpm:0.61\tb2_yesterday_conver:0.12\tb4_yesterday_conver*ctcvr:0.19\tb2_today_conver*ctcvr:0.12\tb2_1d_ctr:0.92\tb3_12h_conver*ctcvr:0.13\tb5_7d_click:0.03\tb3_1d_cvr:0.99\tb8_12h_click:0.04\tb4_3d_cvr:0.98\tb5_3d_conver*log(view):0.07\tb3_7d_ecpm:0.97\tb2_today_cvr:0.93\tb9_7d_ctcvr:0.99\tb2_yesterday_ctcvr:0.5700000000000001\tb5_3d_conver:0.08\tb5_yesterday_ctcvr:0.85\tb3_12h_click:0.02\tb2_1d_conver*log(view):0.3\tb2_3d_conver*ctcvr:0.61\tb8_3d_cvr:0.89\tb5_1d_ecpm:0.98\tb5_1d_ctcvr:0.99\tb5_3d_conver*ctcvr:0.24\tb8_12h_conver*ctcvr:0.21\tb2_3d_ctcvr:0.9400000000000001\tb9_yesterday_conver*log(view):0.16\tb9_yesterday_ctcvr:0.72\tb2_1d_conver:0.3\tb9_3d_ecpm:0.98\tb8_3d_conver*ctcvr:0.13\tb8_12h_ctr:0.96\tb9_yesterday_ecpm:0.73\tb3_7d_conver:0.04      \tb2_yesterday_cvr:0.43\tb8_7d_conver:0.03\tb3_3d_ecpm:0.97\tb8_3d_ctcvr:0.99\tb2_yesterday_ecpm:0.61\tb3_7d_cvr:0.99\tb9_12h_click:0.09\tb2_today_click:0.01\tb4_3d_click:0.02\tb2_7d_ctcvr:0.9400000000000001\tb9_3d_conver*ctcvr:0.23\tb3_3d_conver*ctcvr:0.1\tb4_12h_ecpm:0.99\tb2_today_ecpm:0.93\tb3_3d_click:0.02\tb4_yesterday_click:0.03\tb5_7d_ecpm:0.98\tb5_12h_ctcvr:0.99\tb3_12h_cvr:1.0\tb4_yesterday_ctr:0.93\thour_8:0.1\tb3_7d_click:0.02\tb8_1d_conver:0.06    \tb5_yesterday_cvr:0.75\tb5_12h_ctr:0.9\tb8_7d_ctcvr:0.99\tb2_yesterday_conver*ctcvr:0.47000000000000003\tb9_3d_click:0.09\tb2_1d_cvr:0.9500000000000001\tb2_1d_ecpm:0.9\tb2_3h_click:0.01\tb8_7d_ecpm:0.97\tb4_7d_conver:0.02\tb8_12h_conver:0.03\tb3_yesterday_conver:0.04\tb2_yesterday_click:0.11\tb8_7d_conver*log(view):0.04\tb9_7d_conver:0.09\tb8_12h_cvr:0.99\tb4_12h_conver*ctcvr:0.54\tb5_1d_ctr:0.96\tb3_1d_conver*log(view):0.04\tb9_7d_click:0.07\tb8_yesterday_click:0.05\tb5_yesterday_click:0.04\tb8_yesterday_cvr:0.79\tb3_12h_conver:0.03\tb4_1d_ctcvr:0.99\tb9_1d_conver:0.11\tb4_12h_conver*log(view):0.04\tb4_1d_conver*log(view):0.03\tb9_12h_conver*ctcvr:0.23\tb4_12h_click:0.02\tb8_yesterday_conver:0.05\tb2_7d_cvr:0.9400000000000001\tb2_12h_ctr:0.91\tb5_yesterday_conver*ctcvr:0.28\tb9_yesterday_click:0.11\tb2_3d_click:0.19\tb9_1d_ctr:0.96\tb5_12h_conver*ctcvr:0.27\tb3_yesterday_click:0.02\tb5_1d_click:0.05\tb2_7d_ecpm:0.9400000000000001\tb3_12h_ecpm:0.98\tb3_3d_cvr:0.99\tb5_12h_cvr:0.99\tcpa:0.02\tb2_7d_click:0.22\tb8_3d_conver*log(view):0.04\tb5_12h_conver:0.06\tb5_7d_ctr:0.96\tb9_12h_ecpm:0.98\tb8_3d_click:0.04\tb3_1d_conver:0.04\tb8_3d_ecpm:0.97\tb5_yesterday_ecpm:0.85\tb2_3d_ctr:0.93\tb4_1d_ecpm:0.98")
    result.add("0\tb2_6h_click:0.01\tabcode_ab0:0.1\tb2_3d_conver:0.3\tb9_3d_conver*log(view):0.12\tb8_yesterday_ecpm:0.89\tb8_7d_click:0.03\tb3_1d_ctcvr:0.99\tb7_14d_click:0.04\tb2_today_conver:0.01\tb5_12h_click:0.04\tb2_today_conver*log(view):0.01\tb9_7d_ctr:0.96\tb2_3h_ctr:0.93\tb2_1d_ctcvr:0.96\tb4_1d_ctr:0.96\tb8_12h_conver*log(view):0.05\tb5_1d_cvr:0.99\tb4_12h_ctr:0.97\tb5_3d_ecpm:0.98\tb4_1d_conver:0.02\tb2_7d_conver*log(view):0.61\tb8_1d_ctcvr:0.99\tb9_7d_conver*log(view):0.11\tapptype_4:0.1\tb5_12h_conver*log(view):0.07\tb4_1d_click:0.03\tb9_1d_ctcvr:0.99\tb5_3d_ctcvr:0.99\tb4_yesterday_conver*log(view):0.04\tb4_yesterday_conver:0.02\tb2_12h_ecpm:0.92\tb2_12h_cvr:0.96\tb9_1d_cvr:0.98\tb8_1d_ctr:0.96\tb3_7d_conver*log(view):0.04\tb8_12h_ecpm:0.98\tb3_yesterday_ctr:0.54\tcid_11021:0.1\tb5_7d_conver:0.06\tb8_3d_conver:0.04\tb2_3d_cvr:0.92\tb3_3d_conver:0.04\tb9_yesterday_conver:0.1\tb5_1d_conver*log(view):0.1\tb5_7d_ctcvr:0.99\tb4_7d_ctr:0.96\tb5_7d_cvr:0.99\tb4_yesterday_cvr:0.98\tb9_12h_conver*log(view):0.11\tb2_12h_ctcvr:0.92\tb5_3d_ctr:0.96\tb9_7d_cvr:0.99\tb4_1d_cvr:0.98\tb7_7d_click:0.04\tb3_1d_ctr:0.9500000000000001\tb5_1d_conver:0.1\tb8_yesterday_conver*ctcvr:0.19\tb2_3d_conver*log(view):0.3\tb2_3d_ecpm:0.9400000000000001\tb8_7d_ctr:0.96\tb9_1d_ecpm:0.98\tb4_7d_ecpm:0.98\tb8_1d_cvr:0.91\tb4_3d_ctcvr:0.99\tb9_3d_conver:0.11\tb4_12h_cvr:0.99\tb4_3d_conver:0.02\tb3_1d_click:0.03\tb2_12h_conver:0.13\tb3_1d_ecpm:0.97\tb9_yesterday_ctr:0.67\tb3_1d_conver*ctcvr:0.17\tb4_7d_conver*ctcvr:0.11\tb3_yesterday_conver*ctcvr:0.16\tb4_yesterday_ecpm:0.97\tb9_3d_ctr:0.96\tb3_3d_conver*log(view):0.04\tb2_yesterday_conver*log(view):0.2\tb7_14d_ctr:0.68\tb2_12h_conver*ctcvr:0.35000000000000003\tweight:0.03\tb5_yesterday_conver:0.1\tb3_7d_ctr:0.9500000000000001\tb9_12h_ctr:0.9500000000000001\tb3_12h_ctcvr:0.99\tb2_12h_conver*log(view):0.13\tb4_7d_ctcvr:0.99\tb8_7d_conver*ctcvr:0.11\tb8_yesterday_conver*log(view):0.08\tb9_7d_ecpm:0.98\tb4_3d_conver*log(view):0.02\tb4_1d_conver*ctcvr:0.21\tb2_7d_conver*ctcvr:0.96\tb8_12h_ctcvr:0.99\tb4_7d_cvr:0.98\tb9_1d_click:0.12\tb5_7d_conver*ctcvr:0.18\tb8_7d_cvr:0.89\tb4_3d_ecpm:0.98\tb2_6h_ctr:0.91\tb2_1d_conver*ctcvr:0.59\tb5_1d_conver*ctcvr:0.32\tb3_7d_conver*ctcvr:0.08\tb5_yesterday_conver*log(view):0.09\tb7_7d_ctr:0.68\tb3_12h_ctr:0.9\tdayofweek_1:0.1\tb2_today_ctr:0.93\tb9_7d_conver*ctcvr:0.19\tb4_12h_conver:0.02\tb4_3d_ctr:0.96\tb8_1d_conver*ctcvr:0.21\tb9_12h_conver:0.07\tb5_3d_cvr:0.99\tb4_7d_conver*log(view):0.02\tb5_7d_conver*log(view):0.05\tb9_1d_conver*ctcvr:0.27\tb2_today_ctcvr:0.93\tb4_12h_ctcvr:0.99\tb2_12h_click:0.04\tb8_yesterday_ctr:0.85\tb9_3d_cvr:0.99\tb9_12h_ctcvr:0.99\tb9_yesterday_cvr:0.6900000000000001\tb2_1d_click:0.15\tb8_3d_ctr:0.96\tb3_3d_ctcvr:0.99\tb3_yesterday_ctcvr:0.62\tb5_3d_click:0.04\tb9_yesterday_conver*ctcvr:0.26\tb8_1d_click:0.05\tb3_yesterday_cvr:0.51\tb5_12h_ecpm:0.98\tb3_7d_ctcvr:0.99\tb2_yesterday_ctr:0.54\tb9_12h_cvr:0.99\tb3_12h_conver*log(view):0.02\tb8_1d_ecpm:0.98\tb8_1d_conver*log(view):0.06\tadverid_142:0.1\tb4_yesterday_ctcvr:0.99\tb2_7d_ctr:0.93\tb9_3d_ctcvr:0.99\tb3_3d_ctr:0.9500000000000001\tb4_3d_conver*ctcvr:0.15\tb9_1d_conver*log(view):0.14\tb5_yesterday_ctr:0.77\tb8_yesterday_ctcvr:0.88\tb3_yesterday_conver*log(view):0.08\tb4_7d_click:0.02\tb2_7d_conver:0.61\tb3_yesterday_ecpm:0.61\tb2_yesterday_conver:0.12\tb4_yesterday_conver*ctcvr:0.19\tb2_today_conver*ctcvr:0.12\tb2_1d_ctr:0.92\tb3_12h_conver*ctcvr:0.13\tb5_7d_click:0.03\tb3_1d_cvr:0.99\tb8_12h_click:0.04\tb4_3d_cvr:0.98\tb5_3d_conver*log(view):0.07\tb3_7d_ecpm:0.97\tb2_today_cvr:0.93\tb9_7d_ctcvr:0.99\tb2_yesterday_ctcvr:0.5700000000000001\tb5_3d_conver:0.08\tb5_yesterday_ctcvr:0.85\tb3_12h_click:0.02\tb2_1d_conver*log(view):0.3\tb2_3d_conver*ctcvr:0.61\tb8_3d_cvr:0.89\tb5_1d_ecpm:0.98\tb5_1d_ctcvr:0.99\tb5_3d_conver*ctcvr:0.24\tb8_12h_conver*ctcvr:0.21\tb2_3d_ctcvr:0.9400000000000001\tb9_yesterday_conver*log(view):0.16\tb9_yesterday_ctcvr:0.72\tb2_1d_conver:0.3\tb9_3d_ecpm:0.98\tb8_3d_conver*ctcvr:0.13\tb8_12h_ctr:0.96\tb9_yesterday_ecpm:0.73\tb3_7d_conver:0.04      \tb2_yesterday_cvr:0.43\tb8_7d_conver:0.03\tb3_3d_ecpm:0.97\tb8_3d_ctcvr:0.99\tb2_yesterday_ecpm:0.61\tb3_7d_cvr:0.99\tb9_12h_click:0.09\tb2_today_click:0.01\tb4_3d_click:0.02\tb2_7d_ctcvr:0.9400000000000001\tb9_3d_conver*ctcvr:0.23\tb3_3d_conver*ctcvr:0.1\tb4_12h_ecpm:0.99\tb2_today_ecpm:0.93\tb3_3d_click:0.02\tb4_yesterday_click:0.03\tb5_7d_ecpm:0.98\tb5_12h_ctcvr:0.99\tb3_12h_cvr:1.0\tb4_yesterday_ctr:0.93\thour_8:0.1\tb3_7d_click:0.02\tb8_1d_conver:0.06    \tb5_yesterday_cvr:0.75\tb5_12h_ctr:0.9\tb8_7d_ctcvr:0.99\tb2_yesterday_conver*ctcvr:0.47000000000000003\tb9_3d_click:0.09\tb2_1d_cvr:0.9500000000000001\tb2_1d_ecpm:0.9\tb2_3h_click:0.01\tb8_7d_ecpm:0.97\tb4_7d_conver:0.02\tb8_12h_conver:0.03\tb3_yesterday_conver:0.04\tb2_yesterday_click:0.11\tb8_7d_conver*log(view):0.04\tb9_7d_conver:0.09\tb8_12h_cvr:0.99\tb4_12h_conver*ctcvr:0.54\tb5_1d_ctr:0.96\tb3_1d_conver*log(view):0.04\tb9_7d_click:0.07\tb8_yesterday_click:0.05\tb5_yesterday_click:0.04\tb8_yesterday_cvr:0.79\tb3_12h_conver:0.03\tb4_1d_ctcvr:0.99\tb9_1d_conver:0.11\tb4_12h_conver*log(view):0.04\tb4_1d_conver*log(view):0.03\tb9_12h_conver*ctcvr:0.23\tb4_12h_click:0.02\tb8_yesterday_conver:0.05\tb2_7d_cvr:0.9400000000000001\tb2_12h_ctr:0.91\tb5_yesterday_conver*ctcvr:0.28\tb9_yesterday_click:0.11\tb2_3d_click:0.19\tb9_1d_ctr:0.96\tb5_12h_conver*ctcvr:0.27\tb3_yesterday_click:0.02\tb5_1d_click:0.05\tb2_7d_ecpm:0.9400000000000001\tb3_12h_ecpm:0.98\tb3_3d_cvr:0.99\tb5_12h_cvr:0.99\tcpa:0.02\tb2_7d_click:0.22\tb8_3d_conver*log(view):0.04\tb5_12h_conver:0.06\tb5_7d_ctr:0.96\tb9_12h_ecpm:0.98\tb8_3d_click:0.04\tb3_1d_conver:0.04\tb8_3d_ecpm:0.97\tb5_yesterday_ecpm:0.85\tb2_3d_ctr:0.93\tb4_1d_ecpm:0.98")
    val list = new ArrayBuffer[Map[String, Any]]()
    // 使用 for 循环遍历
    for (element <- result) {
      val map = processString(element)
      list.add(map)

    }
    // 将 Map 转换为 Seq 类型
    val dataSeq: Seq[Map[String, Any]] = list

    // 将 Seq 转换为 RDD
    val rdd: RDD[Map[String, Any]] = sc.parallelize(dataSeq)
    odpsOps.saveToTable(project, table, partition, rdd, write, true, true)
  }

  def write(map: Map[String, Any], record: Record, schema: TableSchema): Unit = {
    for ((columnName, value) <- map) {
      try {
        // 查找列名在表结构中的索引
        val columnIndex = schema.getColumnIndex(columnName)
        // 获取列的类型
        val columnType = schema.getColumn(columnIndex).getTypeInfo
        try {
          columnType.getTypeName match {
            case "STRING" =>
              record.setString(columnIndex, value.toString)
            case "BIGINT" =>
              record.setBigint(columnIndex, value.toString.toLong)
            case "DOUBLE" =>
              record.setDouble(columnIndex, value.toString.toDouble)
            case "BOOLEAN" =>
              record.setBoolean(columnIndex, value.toString.toBoolean)
            case other =>
              throw new IllegalArgumentException(s"Unsupported column type: $other")
          }
        } catch {
          case e: NumberFormatException =>
            println(s"Error converting value $value to type ${columnType.getTypeName} for column $columnName: ${e.getMessage}")
          case e: Exception =>
            println(s"Unexpected error writing value $value to column $columnName: ${e.getMessage}")
        }
      } catch {
        case e: IllegalArgumentException => {
          println(e.getMessage)
        }
      }
    }
  }


  private def processString(input: String): Map[String, Any] = {
    // 去除多余空格并按空格分割成键值对数组
    val parts = input.trim.split("\t")
    var resultMap = Map[String, Any]()
    // 处理第一个元素，假设为特殊标识
    resultMap += ("has_conversion" -> parts(0).toLong)
    // 处理后续的键值对
    parts.drop(1).foreach { part =>
      part.split(":", 2) match {
        case Array(keyStr, valueStr) =>
          val key = keyStr.replace("*", "_x_").replace("(view)", "_view")
          val value = try {
            valueStr.toDouble
          } catch {
            case _: NumberFormatException => valueStr
          }
          resultMap += (key -> value)
        case _ => // 若无法解析成键值对则丢弃
      }
    }
    resultMap
  }
}
